"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = getInitialState;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectWithoutPropertiesLoose"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _router = _interopRequireDefault(require("next/router"));

var _url = require("url");

var _config = _interopRequireDefault(require("./config"));

function getInitialState(_x, _x2) {
  return _getInitialState.apply(this, arguments);
}

function _getInitialState() {
  _getInitialState = (0, _asyncToGenerator2.default)(function* (_ref, opt) {
    var {
      asPath,
      res
    } = _ref;

    if (opt === void 0) {
      opt = {
        ssr: true
      };
    }

    var {
      ssr = true,
      onError
    } = opt,
        options = (0, _objectWithoutPropertiesLoose2.default)(opt, ["ssr", "onError"]);
    var localState = {};
    var {
      nextFetch = 'header'
    } = (0, _config.default)();

    if (res && ssr) {
      if (!res.context.headerSent && res.writable && nextFetch === 'header') {
        res.context.vary('X-Requested-With');
      }

      (0, _assign.default)(localState, res.context.state);
    } else if (!res && asPath) {
      var fetchPath = asPath;

      if (nextFetch === 'header') {
        options.headers = (0, _extends2.default)({}, options.headers, {
          'X-Requested-With': 'Next-Fetch'
        });
      } else if (nextFetch === 'param') {
        var parsed = (0, _url.parse)(fetchPath, true);
        parsed.search = null;
        parsed.query.next_fetch = 'json';
        fetchPath = (0, _url.format)(parsed);
      }

      var _response = yield fetch(fetchPath, (0, _extends2.default)({
        credentials: 'include'
      }, options, {
        redirect: 'follow',
        headers: (0, _extends2.default)({
          Accept: 'application/json, */*;q=0.8'
        }, options.headers)
      }));

      var url = _response.headers.get('Content-Location');

      var json = parseJson(yield _response.text());

      if (url) {
        if (json === 'back') {
          _router.default.back();
        } else {
          var _ref2 = json,
              {
            asPath: as = url
          } = _ref2,
              parsedUrl = (0, _objectWithoutPropertiesLoose2.default)(_ref2, ["asPath"]);

          if (parsedUrl.host || parsedUrl.protocol) {
            window.location.replace(as);
          } else {
            _router.default.replace(parsedUrl, as);
          }
        }

        var error = new Error('Abort due to redirection');
        error.name = 'AbortError';
        error.cancelled = true;
        throw error;
      }

      var {
        status
      } = _response;

      if (status >= 400) {
        if (onError) {
          localState = onError(json, _response);
        } else {
          var {
            message = _response.statusText
          } = json,
              data = (0, _objectWithoutPropertiesLoose2.default)(json, ["message"]);

          var _error = new Error(message);

          _error.statusCode = _error.status = status;
          _error.name = 'AbortError';
          _error.cancelled = true;
          (0, _assign.default)(_error, data);
          throw _error;
        }
      } else {
        localState = json;
      }
    }

    return localState;
  });
  return _getInitialState.apply(this, arguments);
}

function parseJson(text) {
  try {
    return JSON.parse(text);
  } catch (_e) {
    return text;
  }
}