"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

exports.__esModule = true;
exports.withLayout = withLayout;
exports.default = void 0;

var _symbol = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/symbol"));

var _react = _interopRequireDefault(require("react"));

var LAYOUT_SYM = (0, _symbol.default)('next-layout');

function withLayout() {
  for (var _len = arguments.length, layout = new Array(_len), _key = 0; _key < _len; _key++) {
    layout[_key] = arguments[_key];
  }

  return function (page) {
    var layoutPage = page;
    var layouts = layoutPage[LAYOUT_SYM];

    if (layouts) {
      layouts.push(...layout);
    } else {
      layouts = layout;
    }

    layoutPage[LAYOUT_SYM] = unique(layouts);
    return page;
  };
}

function unique(arr) {
  return arr.filter((item, index, self) => index === self.findIndex(t => t === item));
}

var Layout = (_ref) => {
  var {
    component: Component,
    pageProps
  } = _ref;
  var layoutPage = Component;
  var layouts = layoutPage[LAYOUT_SYM];

  var children = _react.default.createElement(Component, pageProps);

  if (layouts && layouts.length) {
    return layouts.reduce((children, ComponentLayout) => _react.default.createElement(ComponentLayout, null, children), children);
  }

  return children;
};

var _default = Layout;
exports.default = _default;