"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = redirect;

var _defineProperty = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectWithoutPropertiesLoose"));

var _url = require("url");

var _router = _interopRequireDefault(require("next/router"));

function redirect(ctx, url) {
  var parsedUrl;

  if (typeof url === 'string') {
    parsedUrl = (0, _url.parse)(url);
  } else {
    parsedUrl = url;
  }

  var {
    asPath: as
  } = parsedUrl,
      parsed = (0, _objectWithoutPropertiesLoose2.default)(parsedUrl, ["asPath"]);
  var formattedUrl = as || (0, _url.format)(parsed);

  if (typeof window === 'undefined') {
    if (ctx.res) {
      ctx.res.context.redirect(formattedUrl);
      ctx.res.context.respond = true;
      ctx.res.finished = true;
    }

    (0, _defineProperty.default)(ctx.res, 'statusCode', {
      set(_statusCode) {},

      get() {
        return 302;
      }

    });
  } else {
    if (parsedUrl.host || parsedUrl.protocol) {
      window.location.href = formattedUrl;
    } else {
      _router.default.push(parsed, as);
    }
  }

  var err = new Error('AbortError');
  err.name = 'AbortError';
  err.cancelled = true;
  throw err;
}